# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AdminEntitlementsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'project_id': 'str',
        'definition': 'CatalogapiadminentitlementsDefinition',
        'migrated': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'project_id': 'projectId',
        'definition': 'definition',
        'migrated': 'migrated'
    }

    def __init__(self, id=None, project_id=None, definition=None, migrated=None):  # noqa: E501
        """AdminEntitlementsBody - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._project_id = None
        self._definition = None
        self._migrated = None
        self.discriminator = None
        self.id = id
        self.project_id = project_id
        self.definition = definition
        if migrated is not None:
            self.migrated = migrated

    @property
    def id(self):
        """Gets the id of this AdminEntitlementsBody.  # noqa: E501

        Entitlement id  # noqa: E501

        :return: The id of this AdminEntitlementsBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AdminEntitlementsBody.

        Entitlement id  # noqa: E501

        :param id: The id of this AdminEntitlementsBody.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def project_id(self):
        """Gets the project_id of this AdminEntitlementsBody.  # noqa: E501

        Project id  # noqa: E501

        :return: The project_id of this AdminEntitlementsBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this AdminEntitlementsBody.

        Project id  # noqa: E501

        :param project_id: The project_id of this AdminEntitlementsBody.  # noqa: E501
        :type: str
        """
        if project_id is None:
            raise ValueError("Invalid value for `project_id`, must not be `None`")  # noqa: E501

        self._project_id = project_id

    @property
    def definition(self):
        """Gets the definition of this AdminEntitlementsBody.  # noqa: E501


        :return: The definition of this AdminEntitlementsBody.  # noqa: E501
        :rtype: CatalogapiadminentitlementsDefinition
        """
        return self._definition

    @definition.setter
    def definition(self, definition):
        """Sets the definition of this AdminEntitlementsBody.


        :param definition: The definition of this AdminEntitlementsBody.  # noqa: E501
        :type: CatalogapiadminentitlementsDefinition
        """
        if definition is None:
            raise ValueError("Invalid value for `definition`, must not be `None`")  # noqa: E501

        self._definition = definition

    @property
    def migrated(self):
        """Gets the migrated of this AdminEntitlementsBody.  # noqa: E501

        Migrated flag for entitlements  # noqa: E501

        :return: The migrated of this AdminEntitlementsBody.  # noqa: E501
        :rtype: bool
        """
        return self._migrated

    @migrated.setter
    def migrated(self, migrated):
        """Sets the migrated of this AdminEntitlementsBody.

        Migrated flag for entitlements  # noqa: E501

        :param migrated: The migrated of this AdminEntitlementsBody.  # noqa: E501
        :type: bool
        """

        self._migrated = migrated

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AdminEntitlementsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdminEntitlementsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
